###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2005 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
%define buildup 1
%define buildsmp 1
%define buildxen 1
%define kernel_version 2.6.17-1.2187_FC5
%define tempversion 2.6.15
%define subversion 0

%ifnarch i686
%define buildsmp 0
%endif 

%ifnarch i686 x86_64
%define buildxen 0
%endif

Name: dlm-kernel
Version: 2.6.15.1
Release: 0.FC5.31
License: GPL
Group: System Environment/Kernel
Summary: dlm-kernel - The Distributed Lock Manager kernel modules.
BuildRequires: kernel = %{kernel_version}
BuildRequires: kernel-devel = %{kernel_version}

%if %{buildsmp}
BuildRequires: kernel-smp = %{kernel_version}
BuildRequires: kernel-smp-devel = %{kernel_version}
BuildRequires: cman-kernel-smp >= 2.6.14
%endif

%if %{buildxen}
BuildRequires: kernel-xen0 = %{kernel_version}
BuildRequires: kernel-xenU = %{kernel_version}
BuildRequires: kernel-xen0-devel = %{kernel_version}
BuildRequires: kernel-xenU-devel = %{kernel_version}
BuildRequires: cman-kernel-xen0 >= 2.6.14
BuildRequires: cman-kernel-xenU >= 2.6.14
%endif

BuildRequires: cman-kernel >= 2.6.14
BuildRequires: cman-kernheaders >= 2.6.14
Conflicts: GFS <= 6.0
Conflicts: GFS-modules GFS-module-smp GFS-module-hugemem
Requires: kernel = %{kernel_version}
Requires: cman-kernel >= 2.6.14
Requires: /lib/modules/%{kernel_version}
Prereq: /sbin/depmod
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}
ExclusiveArch: i686 x86_64
Source0: %{name}-%{tempversion}-%{subversion}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
dlm-kernel - The Distributed Lock Manager kernel modules.

%package -n dlm-kernheaders
Group: Development/System
Summary: dlm kernel header files

%description -n dlm-kernheaders
The dlm kernel headers are used by various cluster packages.

%if %{buildsmp}
%package -n dlm-kernel-smp
Group: System Environment/Kernel
Summary: dlm-kernel-smp - The Distributed Lock Manager kernel modules.
Requires: kernel-smp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}smp
Requires: cman-kernel-smp >= 2.6.11
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}

%description -n dlm-kernel-smp
dlm-kernel-smp - The Distributed Lock Manager kernel-smp modules.
%endif

%if %{buildxen}
%package -n dlm-kernel-xenU
Group: System Environment/Kernel
Summary: dlm-kernel-xenU - The Distributed Lock Manager kernel modules.
Requires: kernel-xenU = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xenU
Requires: cman-kernel-xenU >= 2.6.11
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}

%description -n dlm-kernel-xenU
dlm-kernel-xenU - The Distributed Lock Manager kernel-xenU modules.

%package -n dlm-kernel-xen0
Group: System Environment/Kernel
Summary: dlm-kernel-xen0 - The Distributed Lock Manager kernel modules.
Requires: kernel-xen0 = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xen0
Requires: cman-kernel-xen0 >= 2.6.11
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}

%description -n dlm-kernel-xen0
dlm-kernel-xen0 - The Distributed Lock Manager kernel-xen0 modules.
%endif

################################################################################
##  THE PREP SECTION
################################################################################
%prep
%setup -q -n %{name}-%{tempversion}-%{subversion}
sed  -i -e '/RELEASE_NAME/s/"<CVS>"/"%{version}-%{release}"/' \
       src/dlm_internal.h	
################################################################################
##  THE BUILD SECTION
################################################################################
%build

cp -r `pwd` ../smp
cp -r `pwd` ../xenU
cp -r `pwd` ../xen0

Build_dlm(){
	cpu_type=$1
	flavor=$2
	kernel_src=/lib/modules/%{kernel_version}$flavor/build/
	# Kernel tree setup
	if [ -d $kernel_src/. ]; then
		echo "Kernel %{kernel_version} found."
		echo $kernel_src
	else
		echo "Kernel %{kernel_version} not found."
		echo $kernel_src
		ls /lib/modules/*
		exit 1
	fi

	./configure --kernel_src=$kernel_src --incdir=%{_includedir}
	make %{?_smp_mflags} symverfile=/lib/modules/%{kernel_version}$flavor/kernel/cluster/cman.symvers

	$kernel_src/scripts/mod/modpost -m -i /lib/modules/%{kernel_version}$flavor/kernel/cluster/cman.symvers src/dlm.o -o dlm.symvers
}

%if %{buildup}
Build_dlm %{_target_cpu}
%endif

%if %{buildsmp}
cd ../smp
Build_dlm %{_target_cpu} smp
%endif

%if %{buildxen}
cd ../xenU
Build_dlm %{_target_cpu} xenU
cd ../xen0
Build_dlm %{_target_cpu} xen0
%endif

################################################################################
##  THE INSTALL SECTION
################################################################################
%install
rm -rf $RPM_BUILD_ROOT

%if %{buildup}
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}/kernel/cluster/
%endif
                                                                                
%if %{buildsmp}
cd ../smp
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}smp/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}smp/kernel/cluster/
%endif

%if %{buildxen}
cd ../xenU
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}xenU/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}xenU/kernel/cluster/
cd ../xen0
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}xen0/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}xen0/kernel/cluster/
%endif

################################################################################
##  THE CLEAN SECTION
################################################################################
%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/depmod -e %{kernel_version}

%if %{buildsmp}
%post smp
/sbin/depmod -e %{kernel_version}smp
%endif

%if %{buildxen}
%post xenU
/sbin/depmod -e %{kernel_version}xenU
%post xen0
/sbin/depmod -e %{kernel_version}xen0
%endif

%files
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}/kernel/cluster/*

%if %{buildsmp}
%files -n dlm-kernel-smp
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}smp/kernel/cluster/*
%endif

%if %{buildxen}
%files -n dlm-kernel-xenU
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}xenU/kernel/cluster/*

%files -n dlm-kernel-xen0
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}xen0/kernel/cluster/*
%endif

%files -n dlm-kernheaders
%defattr(-,root,root,-)
%{_includedir}/cluster/*

%changelog
* Fri Mar 31 2006 Chris Feist <cfeist@redhat.com>
- Build xen for x86_64.

* Tue Mar 14 2006 Chris Feist <cfeist@redhat.com>
- Removed 'ARCH=xen' for xen builds.

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 2.6.15.0-20051219.162641.FC5.9.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Fri Jan 13 2006 Chris Feist <cfeist@redhat.com>
- Rebuilt and bumped version number to 2.6.15

* Wed Jan 11 2006 Jesse Keating <jkeating@redhat.com>
- rebuilt again

* Tue Jan 10 2006 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Fri Dec 30 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Wed Dec 28 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Tue Dec 27 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Thu Dec 21 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Mon Dec 19 2005 Chris Feist <cfeist@redhat.com>
- Updated upstream sources.

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Mon May 23 2005 Chris Feist <cfeist@redhat.com>
- Fixed depmod in %post scriptlet to use correct kernel.

* Tue May 17 2005 Chris Feist <cfeist@redhat.com>
- Provide dlm-kernel-modules & ARCH=xen on xen makes.

* Mon May 16 2005 Chris Feist <cfeist@redhat.com>
- Add depmod in %post scriplet.

* Fri May 06 2005 Chris Feist <cfeist@redhat.com>
- Cleaned up .spec file. 

* Fri Apr 29 2005 Chris Feist <cfeist@redhat.com>
- Rebuild for new kernel
- Adding support for i586, xen0 & xenU

* Mon Dec 20 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel & upstream fixes.

* Fri Dec 10 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel & upstream fixes.

* Thu Nov 18 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Fri Oct 22 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Mon Aug 16 2004 Jon Brassow <jbrassow@redhat.com>
- add requires field

* Sat Aug 14 2004 Jon Brassow <jbrassow@redhat.com>
- smp was building but not being packaged
- specify more packages that conflict with this one

* Fri Aug 13 2004 Jon Brassow <jbrassow@redhat.com>
- various bug fixes (new upstream sources)
- no need for make file patch

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- update patch for a Makefile

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- add patch for a Makefile

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- be more explicit in files section

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- bump rev number and fix typo

* Thu Jun 17 2004 Jon Brassow <jbrassow@redhat.com> 
- Initial build.
